# -*-python-*-

__package__    = "flgrowler.py"
__version__    = "1.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/flgrowler/"
__cvsversion__ = "$Revision: 1.3 $"
__date__       = "$Date: 2008/01/04 06:23:32 $"
__copyright__  = "Copyright (c) 2007 Aaron Straup Cope. Perl Artistic License."

import string
import md5
import urllib
import urllib2
import elementtree.ElementTree as ET
import growler
import time

class flgrowler (growler.growler) :

    def __init__ (self, cfg) :
        growler.growler.__init__(self, cfg)
        self.api_endpoint = "http://api.flickr.com/services/rest"
        
    #
    
    def api_call (self, method, args={}) :
        
        args['method'] = method
        args['api_key'] = self.cfg.get(self.name, "api_key")
        args['auth_token'] = self.cfg.get(self.name, "auth_token")
        args['api_sig'] = self.sign_args(args)

        url = '%s?%s' % (self.api_endpoint, urllib.urlencode(args))

        try : 
            response = urllib2.urlopen(url)
            xml = response.read()

            # self.log(xml)
                
        except Exception, e :
            self.log("failed to call %s method : %s" % (method, e))
            return False

        try :
            tree = ET.fromstring(xml)

            if tree.attrib['stat'] == 'fail' :
                err = tree.find("err")
                self.log("failed to call %s method : %s, %s" % (method, err.attrib['code'], err.attrib['msg']))
                self.log(url)
                return False

        except Exception, e :
            self.log("failed to parse %s method : %s" % (method, e))
            return False
            
        return tree
    
    #
    
    def sign_args (self, args) :

        secret = self.cfg.get(self.name, "api_secret")

        params = args.keys()
        params.sort()

        sig = unicode(secret)
        
        for key in params :
            sig += unicode(key) + unicode(args[key])

        return md5.md5(sig).hexdigest()

    #
    
    def notify (self, event) : 

        title = event['photo']['title']
        desc = self.format_event(event)
    
        try :
            icon = self.fetch_thumb(event['photo']['thumb'])
            self.growl.notify(self.name, title, desc, icon, True)
        except Exception, e :
            return False

        return True

    #
